/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//機能名称 
//		  getValue用のクラス
//変更履歴
//			  2003.11.24	zcj  新規作成		
//
package jp.co.ntt.lms.lo.scorm.cbtcom;

/**
 * getValue用のクラス
 * @author zhaicj
 * 
 */
public class MaintenanceGetValue implements IMaintenanceGetValue {
	/**
	 * データモデル区分
	 */
	private String strModal = null;
   
	/**
	 * MaintenanceGetValueクラスのコンストラクタ<br>
	 * @param name String データモデル名
	 */
    public MaintenanceGetValue(String name) {
    	this.strModal = name;
    }
	   
	/**
     * getValueのメソッド<br>
     * @param element CMIElement データモデルエレメント
     * @param name StringBuffer 名前
     * @return String 取得の値
     */
    public String getValue(CMIElement element, StringBuffer name) {
		if ( "getvalue_LessonStatus".equals( strModal ) ) {
    		return getvalue_LessonStatus( element, name );
    	} else {
    		return null;
    	}
    }
   
	/**
	 * LessonStatusを取得する<br>
	 * @param element CMIElement データモデルエレメント
	 * @param name StringBuffer 名前
	 * @return String 取得の値
	 */
	private String getvalue_LessonStatus(CMIElement element, StringBuffer name) {
		String retStr = null;
		CMICBT cbt = element.getCBT();
		// LessonValue を返す
		retStr = element.getLessonValue();
		// AICCのバージョンに関わらず、合格判定を行うように修正
		if ( retStr == null ) {
			// LessonValueが未設定の場合（セッション開始前）
			// LocalValue を返す
			retStr = element.getLocalValue();	
		}
		// バージョンの取得
		//	int	version = element->getVersion();
	
		if ( !element.isSetValue() ) {
			// core.lesson_modeの値を確認して"browse"であれば、
			// lesson_statusの値を"browsed"に変更する
			CMIElement cmielement = cbt.getNChild("core.lesson_mode");
			String value_Mode = cmielement.getLocalValue();

			if ( value_Mode != null ) {
				String value = value_Mode;
				value = value.toLowerCase();

				// lesson_modeの値が"browse"の場合、"browsed"をセットして終了
				if (value.startsWith("b")){
					retStr = "Browsed";
					return retStr;
				}
			}
			// AICCのバージョンに関わらず、合格判定を行うように修正
			cmielement = cbt.getNChild("core.credit");
			String value_Credit = cmielement.getLocalValue();
			if ( value_Credit != null ) {
				String value = value_Credit;
				value = value.toLowerCase();
				if ( !value.startsWith("n") ){
					// mastery_score と score を比較し lesson_status を更新する
					cmielement = cbt.getNChild("student_data.mastery_score");
					String value_Mastery = cmielement.getLocalValue();

					// 比較対象のスコアモデル名を取得する
					// 　AICC2.xの場合、score.raw
					// 　SCORM1.3の場合、score.scaled
					String strScoreName = CMIS13ModelUtil.getCheckScoreName();
					cmielement = cbt.getNChild(strScoreName);
					String value_Score = cmielement.getLessonValue();
					if (((value_Mastery != null) &&
							("".equals(value_Mastery) != true))
						&& ((value_Score != null) &&
							("".equals(value_Score) != true))) {

						// lesson_status の初期値
						long  lvalue_Mastery ;
						long  lvalue_Score ;
						
						try{
							lvalue_Mastery = Float.valueOf(value_Mastery).longValue();						
						}catch(NumberFormatException ex){
							ex.printStackTrace();
							lvalue_Mastery = 0;					
						}
						try{
							lvalue_Score = Float.valueOf(value_Score).longValue();
						}catch(NumberFormatException ex){
							ex.printStackTrace();
							lvalue_Score = 0;
						}
						if ( lvalue_Mastery  <=  lvalue_Score) {
								retStr = "passed";
						}
						// スコアが合格点に達しない場合
						else {
							retStr = "failed";
						}
					}
				}
			}
		}
		return retStr;
	}
}
